'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StringColorParser = function (_Component) {
  (0, _inherits3.default)(StringColorParser, _Component);
  (0, _createClass3.default)(StringColorParser, null, [{
    key: 'getRegExp',
    value: function getRegExp(props) {
      var searchWords = props.searchWords;

      if (!(searchWords instanceof Array)) {
        throw new Error('Search Words should be an Array type!!!');
      }
      var string = searchWords.reduce(function (result, current) {
        return result.concat(current + '|');
      }, '');
      return new RegExp(string, 'g');
    }
  }]);

  function StringColorParser(props) {
    (0, _classCallCheck3.default)(this, StringColorParser);

    var _this = (0, _possibleConstructorReturn3.default)(this, (StringColorParser.__proto__ || (0, _getPrototypeOf2.default)(StringColorParser)).call(this, props));

    _this.highlights = null;
    _this.textarea = null;

    _this.handleInput = _this.handleInput.bind(_this);
    _this.handleScroll = _this.handleScroll.bind(_this);

    _this.searchWordsRegExp = StringColorParser.getRegExp(props) || '';
    return _this;
  }

  (0, _createClass3.default)(StringColorParser, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.searchWords !== this.props.searchWords) {
        this.searchWordsRegExp = StringColorParser.getRegExp(this.props);
        this.handleInput(this.textarea.value);
      }
    }
  }, {
    key: 'handleInput',
    value: function handleInput(value) {
      this.highlights.innerHTML = this.parseString(value);
    }
  }, {
    key: 'handleScroll',
    value: function handleScroll() {
      this.highlights.scrollTop = this.textarea.scrollTop;
      this.highlights.scrollLeft = this.textarea.scrollLeft;
    }
  }, {
    key: 'getOpeningTag',
    value: function getOpeningTag(tag, depth) {
      var _props = this.props,
          _props$colors = _props.colors,
          colors = _props$colors === undefined ? [] : _props$colors,
          defaultColor = _props.defaultColor,
          solidHighlight = _props.solidHighlight;

      var color = colors[depth - 1] || defaultColor;
      var style = solidHighlight ? 'background-color:' + color + ';' : 'color:' + color + ';';
      return '<' + tag + ' style="' + style + '">';
    }
  }, {
    key: 'parseString',
    value: function parseString(input) {
      var _this2 = this;

      var _props2 = this.props,
          delimiters = _props2.delimiters,
          tag = _props2.tag,
          searchWords = _props2.searchWords;

      var stack = [];
      var string = '';
      var depth = 0;
      if (delimiters && !searchWords) {
        var _loop = function _loop(_i) {
          var startDelimitersPair = delimiters.find(function (_ref) {
            var start = _ref.start;
            return input.substr(_i, start.length) === start;
          });
          var endDelimitersPair = delimiters.find(function (_ref2) {
            var end = _ref2.end;
            return input.substr(_i, end.length) === end;
          });
          if (endDelimitersPair && depth > 0) {
            if (stack[stack.length - 1] === endDelimitersPair.start) {
              depth -= 1;
              stack.pop();
              string += '</' + tag + '>' + endDelimitersPair.end;
            } else {
              string += endDelimitersPair.end;
            }
            _i += endDelimitersPair.end.length;
          } else if (startDelimitersPair) {
            depth += 1;
            stack.push(startDelimitersPair.start);
            string += '' + startDelimitersPair.start + _this2.getOpeningTag(tag, depth);
            _i += startDelimitersPair.start.length;
          } else {
            string += input.charAt(_i);
            _i += 1;
          }
          i = _i;
        };

        for (var i = 0; i < input.length;) {
          _loop(i);
        }
        return string;
      } else if (searchWords && !delimiters) {
        return input.replace(/\n$/g, '\n\n').replace(this.searchWordsRegExp, this.getOpeningTag(tag, 1) + '$&</' + tag + '>');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var fontSize = this.props.fontSize;

      return _react2.default.createElement(
        'div',
        { className: 'parse-string-container' },
        _react2.default.createElement('div', {
          ref: function ref(hl) {
            return _this3.highlights = hl;
          },
          style: { fontSize: fontSize },
          className: 'highlights'
        }),
        _react2.default.createElement('textarea', {
          ref: function ref(ta) {
            return _this3.textarea = ta;
          },
          style: { fontSize: fontSize },
          onChange: function onChange(_ref3) {
            var value = _ref3.target.value;
            return _this3.handleInput(value);
          },
          onScroll: this.handleScroll
        })
      );
    }
  }]);
  return StringColorParser;
}(_react.Component);

StringColorParser.defaultProps = {
  tag: 'span',
  fontSize: 16,
  defaultColor: 'lightsalmon',
  solidHighlight: false
};

exports.default = StringColorParser;
module.exports = exports['default'];
//# sourceMappingURL=StringColorParser.js.map